#include "embedding.h"

chomik::program the_program;
chomik::parser the_parser{the_program};

int main(int argc, char *argv[])
{
    int return_value = 0;
    chomik::parser::register_parser(&the_parser);
    std::string filename="a_valid_path_to_the_chomik_code/some_chomik_code.chomik";

    if (the_parser.parse(filename.c_str()) == 0)
    {
        chomik::machine m;
        m.create_predefined_types();
        m.create_predefined_variables();
        m.create_predefined_streams();

        the_program.execute(m);

        chomik::generic_name gn;
        gn.add_generic_name_item(std::make_shared<chomik::identifier_name_item>("the"));
        gn.add_generic_name_item(std::make_shared<chomik::identifier_name_item>("program"));
        gn.add_generic_name_item(std::make_shared<chomik::identifier_name_item>("return"));
        chomik::signature s0{gn};

        return_value = m.get_variable_value_integer(s0);
    }
    return return_value;
}
